import gsdl2


def set_caption():
    s = '06_font.py - N: {} | B: {} | I: {} | S: {} | U: {} | O: {}'.format(
        font.get_normal(), font.get_bold() > 0, font.get_italic() > 0, font.get_strikethrough() > 0,
        font.get_underline() > 0, font.get_outline() > 0)
    gsdl2.display.set_caption(s)


def render_text(text):
    surf = font.render(text, fg_color)
    texture = gsdl2.texture.Texture(renderer, surf)
    rect = texture.get_rect(center=screen_rect.center)
    return texture, rect


gsdl2.init()

screen = gsdl2.display.set_mode((1024, 480))
screen_rect = screen.get_rect()
renderer = gsdl2.display.get_window().create_renderer()
clock = gsdl2.Clock()
fps = 33

font = gsdl2.Font('Vera.ttf', 48)
fg_color = gsdl2.Color(255, 0, 255)

font.set_outline(True)
font.set_underline(True)

set_caption()

words = 'ABCDEFG HIJKLMN OPQRST UVWXYZ'
word_texture, word_rect = render_text(words)

running = True

while running:
    clock.tick(fps)

    for e in gsdl2.event.get():
        if e.type == gsdl2.sdl_lib.SDL_QUIT:
            running = False
        elif e.type == gsdl2.sdl_lib.SDL_KEYDOWN:
            if e.key == gsdl2.sdlkeys.SDLK_ESCAPE:
                running = False
            else:
                if e.key == gsdl2.sdlkeys.SDLK_n:
                    font.set_normal()
                elif e.key == gsdl2.sdlkeys.SDLK_b:
                    font.set_bold(font.get_bold() == 0)
                elif e.key == gsdl2.sdlkeys.SDLK_i:
                    font.set_italic(font.get_italic() == 0)
                elif e.key == gsdl2.sdlkeys.SDLK_o:
                    font.set_outline(font.get_outline() == 0)
                elif e.key == gsdl2.sdlkeys.SDLK_s:
                    font.set_strikethrough(font.get_strikethrough() == 0)
                elif e.key == gsdl2.sdlkeys.SDLK_u:
                    font.set_underline(font.get_underline() == 0)
                word_texture, word_rect = render_text(words)
                set_caption()

    renderer.clear()
    renderer.copy(word_texture, word_rect)
    renderer.present()
