__all__ = ['Color']


import logging

from .sdlffi import sdl_ffi


log = logging.getLogger(__name__)


class Color(object):

    def __init__(self, *args):
        assert len(args)

        self.__sdl_color = sdl_ffi.new('SDL_Color *')

        if isinstance(args[0], str):
            raise NotImplemented
        else:
            c = self.__sdl_color
            c.r = args[0]
            c.g = args[1]
            c.b = args[2]
            c.a = 0 if len(args) == 3 else args[3]

    def __getr(self):
        return self.__sdl_color.r
    def __setr(self, r):
        self.__sdl_color.r = r
    r = property(__getr, __setr)

    def __getg(self):
        return self.__sdl_color.g
    def __setg(self, g):
        self.__sdl_color.g = g
    g = property(__getg, __setg)

    def __getb(self):
        return self.__sdl_color.b
    def __setb(self, b):
        self.__sdl_color.b = b
    b = property(__getb, __setb)

    def __geta(self):
        return self.__sdl_color.a
    def __seta(self, a):
        self.__sdl_color.a = a
    a = property(__geta, __seta)

    def __get_sdl_color(self):
        return self.__sdl_color
    sdl_color = property(__get_sdl_color)

    def __iter__(self):
        c = self.__sdl_color
        for v in c.r, c.g, c.b, c.a:
            yield v

    def __str__(self):
        return '<{}({}, {}, {}, {})>'.format(self.__class__.__name__, *tuple(self))
