from collections import namedtuple

from .sdllibs import sdl_lib
from .sdlffi import sdl_ffi


# TODO: __all__


# TODO: more event types
KeyDownEvent = namedtuple('KeyDownEvent', 'type key mod')
QuitEvent = namedtuple('QuitEvent', 'type')


def Event():
    return sdl_ffi.new('SDL_Event *')

# TODO: def Event()


_event = Event()


def get():
    events = []
    append = events.append
    e = _event
    while sdl_lib.SDL_PollEvent(_event):
        # for name in dir(e):
        #     print(name, type(getattr(e, name)))
        # quit()
        event_type = e.type
        if event_type == sdl_lib.SDL_KEYDOWN:
            append(KeyDownEvent(event_type, chr(e.key.keysym.sym), e.key.keysym.mod))
        elif event_type == sdl_lib.SDL_QUIT:
            append(QuitEvent(event_type))
    return events
